(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict"; /** 
               * Copyright info
               * 
               * @author Jasper van Dijk
               * 
               * @link https://www.jaspervdijk63.github.io
               * @copyright © 2020 HR3Edits (Jasper van Dijk)
               * Please do not copy or edit this addon, neither reshare or publish it on any other websites.
              */

var serverSystem = server.registerSystem(0, 0);
const displayChat = "minecraft:display_chat_event";

var currentPlayerId = undefined;
var lastEventData = undefined;

var players = {};



serverSystem.initialize = function () {
  const scriptLoggerConfig = serverSystem.createEventData("minecraft:script_logger_config");
  scriptLoggerConfig.data.log_errors = true;
  scriptLoggerConfig.data.log_information = true;
  scriptLoggerConfig.data.log_warnings = true;
  serverSystem.broadcastEvent("minecraft:script_logger_config", scriptLoggerConfig);

  this.listenForEvent("minecraft:player_placed_block", eventData => this.pos(eventData));

  this.listenForEvent("minecraft:entity_use_item", eventData => this.itemUse(eventData));

  this.listenForEvent("hr3worldedit:uiEventData", buttonClicked => this.interaction(buttonClicked));

  this.listenForEvent("hr3worldedit:scanBlockPos", HitEventData => this.blockPosRec(HitEventData));

  this.registerEventData("hr3worldedit:loadUI", {});
  this.registerEventData("hr3worldedit:scanBlock", {});
};

serverSystem.itemUse = function (eventData) {
  if (eventData.data.item_stack.item == "minecraft:fishing_rod") {
    var scanBlocker = serverSystem.createEventData('hr3worldedit:scanBlock');
    serverSystem.broadcastEvent('hr3worldedit:scanBlock', scanBlocker);
  }
};

serverSystem.blockPosRec = function (eventData) {
  let posData = eventData.data.pos;
  serverSystem.executeCommand(`/fill ${posData.x - 2} ${posData.y + 3} ${posData.z - 2} ${posData.x + 2} ${posData.y + 6} ${posData.z + 2} sand`, commandResultData => serverSystem.commandCallback(commandResultData));
};

serverSystem.interaction = function (eventData) {
  let pos1;
  let pos2;
  let pos3;

  if (players.hasOwnProperty(currentPlayerId)) {
    let id = currentPlayerId;
    let coords = players[id];

    pos1 = coords.pos1;
    pos2 = coords.pos2;
    pos3 = coords.pos3;
  } else {
    if (handItem.item === "minecraft:ice") {
      let id = currentPlayerId;
      let idObject = {
        id: {
          pos1: {
            x: blockPos.x,
            y: blockPos.y,
            z: blockPos.z },

          pos2: undefined,
          pos3: undefined } };


      players[id] = idObject;
    }
  }
  placeFunction(pos1, pos2, pos3, lastEventData, eventData.data.item, eventData.data.hollow);
};


serverSystem.pos = function (eventData) {
  let handContainer = serverSystem.getComponent(eventData.data.player, "minecraft:hand_container");
  let handItem = handContainer.data[0];

  let pos1;
  let pos2;
  let pos3;

  let blockPos = eventData.data.block_position;

  if (players.hasOwnProperty(eventData.data.player.id)) {
    let id = eventData.data.player.id;
    let coords = players[id];

    pos1 = coords.pos1;
    pos2 = coords.pos2;
    pos3 = coords.pos3;
  } else {
    if (handItem.item === "minecraft:ice") {
      let id = eventData.data.player.id;
      let idObject = {
        id: {
          pos1: {
            x: blockPos.x,
            y: blockPos.y,
            z: blockPos.z },

          pos2: undefined,
          pos3: undefined } };


      players[id] = idObject;
    }
  }

  if (handItem.item === "minecraft:ice") {
    if (typeof pos1 !== 'undefined') {
      if (typeof pos2 !== 'undefined') {
        let myMessage = serverSystem.createEventData(displayChat);
        myMessage.data.message = "§aPosition1 has been set!";
        serverSystem.broadcastEvent(displayChat, myMessage);
        players[eventData.data.player.id].pos1 = blockPos;
        serverSystem.executeCommand(`/setblock ${blockPos.x} ${blockPos.y} ${blockPos.z} air`, commandResultData => serverSystem.commandCallback(commandResultData));
        delete players[eventData.data.player.id].pos2;
        return;
      }
      players[eventData.data.player.id].pos2 = blockPos;
      serverSystem.executeCommand(`/setblock ${blockPos.x} ${blockPos.y} ${blockPos.z} air`, commandResultData => serverSystem.commandCallback(commandResultData));
      sendMSG('§aPosition2 has been set!');
    } else {
      players[eventData.data.player.id].pos1 = blockPos;
      serverSystem.executeCommand(`/setblock ${blockPos.x} ${blockPos.y} ${blockPos.z} air`, commandResultData => serverSystem.commandCallback(commandResultData));
      sendMSG('§aPosition1 has been set!');
    }
  } else if (handItem.item === "minecraft:blue_ice") {
    if (pos3 !== undefined) {
      delete players[eventData.data.player.id].pos3;
      sendMSG('§cRemoved clone to position');
      return;
    }
    players[eventData.data.player.id].pos3 = blockPos;
    serverSystem.executeCommand(`/setblock ${blockPos.x} ${blockPos.y} ${blockPos.z} air`, commandResultData => serverSystem.commandCallback(commandResultData));
    sendMSG('§aClone pos has been set!');
  } else if (handItem.item === "minecraft:packed_ice") {
    serverSystem.executeCommand(`/setblock ${blockPos.x} ${blockPos.y} ${blockPos.z} air`, commandResultData => serverSystem.commandCallback(commandResultData));
    if (currentPlayerId !== undefined || lastEventData !== undefined) {
      sendMSG('player is already selecting block');
      return;
    }
    if (pos1 == undefined || pos2 == undefined) {
      sendMSG("§cPlease set positions first!");
      return;
    }
    currentPlayerId = eventData.data.player.id;
    lastEventData = eventData;

    let loadUIEventData = this.createEventData("hr3worldedit:loadUI");
    this.broadcastEvent("hr3worldedit:loadUI", loadUIEventData);
  }
};

serverSystem.set = function (eventData) {
  let myMessage = serverSystem.createEventData(displayChat);
  myMessage.data.message = "§ctest!";
  serverSystem.broadcastEvent(displayChat, myMessage);
};

function sendMSG(msg) {
  let myMessage = serverSystem.createEventData(displayChat);
  myMessage.data.message = msg;
  serverSystem.broadcastEvent(displayChat, myMessage);
}

function placeFunction(pos1, pos2, pos3, eventData, item, hollow) {
  if (pos1 == undefined || pos2 == undefined) {
    sendMSG("§cPlease set positions first!");
    return;
  }

  if (item == "grass_rep") {
    serverSystem.executeCommand(`/fill ${pos1.x} ${pos1.y} ${pos1.z} ${pos2.x} ${pos2.y} ${pos2.z} grass 0 replace sand 0`, commandResultData => serverSystem.commandCallback(commandResultData));
    sendMSG(`§aDone replacing your blocks!`);
    currentPlayerId = undefined;
    lastEventData = undefined;
    return;
  } else if (item == "stone_rep") {
    serverSystem.executeCommand(`/fill ${pos1.x} ${pos1.y} ${pos1.z} ${pos2.x} ${pos2.y} ${pos2.z} stone 0 replace sand 0`, commandResultData => serverSystem.commandCallback(commandResultData));
    sendMSG(`§aDone replacing your blocks!`);
    currentPlayerId = undefined;
    lastEventData = undefined;
    return;
  }

  if (item == "clone") {
    if (pos3 !== undefined) {
      serverSystem.executeCommand(`/clone ${pos1.x} ${pos1.y} ${pos1.z} ${pos2.x} ${pos2.y} ${pos2.z} ${pos3.x} ${pos3.y} ${pos3.z}`, commandResultData => serverSystem.commandCallback(commandResultData));
      delete players[eventData.data.player.id].pos3;
      sendMSG("§aCloned it!");
    } else {
      sendMSG("§cPlease set clone position first!");
    }
    currentPlayerId = undefined;
    lastEventData = undefined;
    return;
  } else if (item == "cancel") {
    sendMSG("§ccancelled it!");
    currentPlayerId = undefined;
    lastEventData = undefined;
    return;
  } else

  if (item == "file") {
    cloneToFile(pos1, pos2);
    return;
  }

  if (hollow) {
    serverSystem.executeCommand(`/fill ${pos1.x} ${pos1.y} ${pos1.z} ${pos2.x} ${pos2.y} ${pos2.z} ${item} hollow`, commandResultData => serverSystem.commandCallback(commandResultData));
    sendMSG(`§aDone filling your blocks!`);
    currentPlayerId = undefined;
    lastEventData = undefined;
    return;
  }
  serverSystem.executeCommand(`/fill ${pos1.x} ${pos1.y} ${pos1.z} ${pos2.x} ${pos2.y} ${pos2.z} ${item}`, commandResultData => serverSystem.commandCallback(commandResultData));
  sendMSG(`§aDone filling your blocks!`);
  currentPlayerId = undefined;
  lastEventData = undefined;
}

function cloneToFile(pos1, pos2) {
  let tickingAreas = serverSystem.getComponent(server.level, "minecraft:ticking_areas");
  if (!tickingAreas.data['cloneAREA']) {
    //niet clone area
    if (tickingAreas.data['copyAREA']) {
      serverSystem.executeCommand(`/tickingarea remove copyAREA`, commandResultData => serverSystem.commandCallback(commandResultData));
    }
    serverSystem.executeCommand(`/tickingarea add ${pos1.x} ${pos1.y} ${pos1.z} ${pos2.x} ${pos2.y} ${pos2.z} cloneAREA`, commandResultData => serverSystem.commandCallback(commandResultData));
    return;
  } else {
    //hij heeft clone area
    if (tickingAreas.data['cloneAREA']) {
      serverSystem.executeCommand(`/tickingarea remove cloneAREA`, commandResultData => serverSystem.commandCallback(commandResultData));
    }
    serverSystem.executeCommand(`/tickingarea add ${pos1.x} ${pos1.y} ${pos1.z} ${pos2.x} ${pos2.y} ${pos2.z} copyAREA`, commandResultData => serverSystem.commandCallback(commandResultData));
    return;
  }
}

function cloneToFileResult(dataType) {
  if (players.hasOwnProperty(currentPlayerId)) {
    let id = currentPlayerId;
    let coords = players[id];
    //set let coords and pos
    let pos1 = coords.pos1;
    let pos2 = coords.pos2;

    let tickingAreas = serverSystem.getComponent(server.level, "minecraft:ticking_areas");
    sendMSG(dataType);
    let blocks = serverSystem.getBlocks(tickingAreas.data[dataType], pos1.x, pos1.y, pos1.z, pos2.x, pos2.y, pos2.z);
    sendMSG(Object.keys(blocks).length);
  }
  currentPlayerId = undefined;
  lastEventData = undefined;
}

serverSystem.commandCallback = function (commandResultData) {
  let eventData = this.createEventData("minecraft:display_chat_event");
  if (eventData) {
    eventData.data.message = "Callback called! Command: " + commandResultData.command + " Data: " + JSON.stringify(commandResultData.data, null, "    ");
    //this.broadcastEvent("minecraft:display_chat_event", eventData);
  }
  if (commandResultData.command.includes("/tickingarea add")) {
    if (commandResultData.command.includes('cloneAREA')) {
      cloneToFileResult('copyAREA');
    } else {
      cloneToFileResult('cloneAREA');
    }
  }
};

serverSystem.update = function () {

};

},{}]},{},[1]);
